#include <stdio.h>
#include <stdlib.h>

#include "fossil.h"

// Beim IPC Chip ist die Schnittstelle EXT 0 und COM 1
int portnum = 0;


void fossil_init ()
{

        asm {
                // Initialisierung vom FOSSIL Treiber
                mov     ah, 0x04
                // dx = IO-Port nummer. ACHTUNG: fr den IPC muss dx=1 sein!
                mov     dx, portnum
                int     0x14
        };

        if (_AX != 0x1954)
        {
                printf ("could not initialize fossil driver. exiting.\n");
                exit (0);
        }

        // 9600 baud, 8bit, keine paritaet setzen
        asm {
                xor     ah, ah
                mov     al, 243         // = binr 1110011
                mov     dx, portnum
                int     0x14
        };

        return;
};

void fossil_done ()
{
        asm {
                mov     ah, 0x05
                mov     dx, portnum
                int     0x14
        }
        return;
}

void fossil_write (unsigned char data)
{
        asm {
                mov     ah, 0x01
                mov     al, data
                mov     dx, portnum
                int     0x14
        };
        return;
};

unsigned char fossil_checkrec ()
{
        unsigned char foo;

        asm {
                mov     ah, 0x03
                mov     dx, portnum
                int     0x14
                mov     foo, ah
        };

        return (foo);
}

unsigned char fossil_read ()
{
        unsigned char foo;

        asm {
                mov     ah, 0x02
                mov     dx, portnum
                int     0x14
                mov     foo, al
        };


        return (foo);
}
